{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.6
  Fecha versión actual: 29-06-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    30-10-2001    El orden de las columnas es:
                      - Número factura
                      - Nombre del proveedor
                      - CIF
                      - Fecha de alta
                      - Importe del IVA (4 decimales)
                      - Importe total (2 decimales)
                      - Concepto de factura

    20-01-2002    Se ha rediseñado el informe para usar Word directamente en
                  vez de exportación a RTF. Ahora el informe se agrupa por
                  meses.

    26-01-2002    El informe ahora saca el listado por intervalo de fechas
                  de facturas.

    26-01-2002    Se ha añadido la columna 'Base imponible' en el informe.

    06-02-2002    También se debe realizar la suma total para las columna
                  'Base imponible' e 'Importe IVA'.

    07-04-2002    Se ha adaptado para la transacción única.

    29-06-2004    p272. Adaptación a multiempresa.

    29-06-2004    p274. Migración a FastReport.
===============================================================================
}

unit InformeListadoFacturasProvIVA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  InformeBase, IBDatabase, Db, FR_IBXDB, FR_Shape, FR_Class, FR_DSet,
  FR_DBSet, IBCustomDataSet, IBQuery, Tipos;

type
  TdmInformeListadoFacturasProvIVA = class(TdmInformeBase)
    TablaFacturas: TIBQuery;
    frdsTablaFacturas: TfrDBDataSet;
  private
    FFechaIni: Variant;
    FFechaFin: Variant;
    FTipo: TTipoInforme;
    FCodigoProveedor: Variant;
    FNombreProveedor: Variant;
    procedure InformeGetParametersText(Memo : TStringList);
  protected
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property FechaIni : Variant read FFechaIni write FFechaIni;
    property FechaFin : Variant read FFechaFin write FFechaFin;
    property CodigoProveedor : Variant read FCodigoProveedor write FCodigoProveedor;
    property NombreProveedor : Variant read FNombreProveedor write FNombreProveedor;
    property Tipo : TTipoInforme read FTipo write FTipo;
  end;

var
  dmInformeListadoFacturasProvIVA: TdmInformeListadoFacturasProvIVA;

implementation

{$R *.DFM}

{ TdmInformeListadoFacturasCliIVA }

uses
  RdxEmpresaActiva, Literales;

constructor TdmInformeListadoFacturasProvIVA.Create(
  AOwner: TComponent);
begin
  inherited;
  FFechaIni := NULL;
  FFechaFin := NULL;
  FCodigoProveedor := NULL;
  FNombreProveedor := NULL;
  FTipo := tiTodo;
  FNombreInforme := 'ListadoFacturasProvIVA.frf';
  OnGetParametersText := InformeGetParametersText;
end;

procedure TdmInformeListadoFacturasProvIVA.InformeGetParametersText(
  Memo: TStringList);
begin
  with Memo do
  begin
    if Tipo = tiTodo then
      Add(msgInfIntervaloTodosPro)
    else
      Add(SysUtils.Format('%s - %s', [FCodigoProveedor, FNombreProveedor]));
    Add(SysUtils.Format(msgInfIntervaloFec, [FFechaIni, FFechaFin]))
  end;
end;

procedure TdmInformeListadoFacturasProvIVA.PrepararConsultas;
begin
  with TablaFacturas do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select NOMBRE, CODIGO, FECHAALTA, NIFCIF, ');
    SQL.Add('IMPORTEIVA, IMPORTETOTAL, NOTAS, (BASEIMPONIBLE-IMPORTEDESCUENTO) AS BASEIMPONIBLE,');
    SQL.Add('EXTRACT (MONTH FROM FECHAALTA)||''/''||EXTRACT (YEAR FROM FECHAALTA) as MES ');
    SQL.Add('from FACTURASPROVEEDOR ');
    SQL.Add('where FECHAALTA between :FECHAINI and :FECHAFIN ');
    SQL.Add('and CODIGOEMPRESA = :CODIGOEMPRESA ');
    if Tipo = tiPorProveedor then
    begin
      SQL.Add('and CODIGOPROVEEDOR = :CODIGOPROVEEDOR ');
      ParamByName('CODIGOPROVEEDOR').AsString := FCodigoProveedor;
    end;
    SQL.Add('order by FECHAALTA, NOMBRE, CODIGO');

    ParamByName('FECHAINI').AsDate := FFechaIni;
    ParamByName('FECHAFIN').AsDate := FFechaFin;
    ParambyName('CODIGOEMPRESA').AsInteger := EmpresaActiva.Codigo;
    Prepare;
  end;
end;

end.
